/* Generated automatically by the program `genextract'
from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "toplev.h"

static rtx junk ATTRIBUTE_UNUSED;
void
insn_extract (insn)
     rtx insn;
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED;

  memset (ro, 0, sizeof (*ro) * MAX_RECOG_OPERANDS);
  memset (ro_loc, 0, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
  switch (INSN_CODE (insn))
    {
    case -1:
      fatal_insn_not_found (insn);

    case 571:
    case 570:
      for (i = XVECLEN (pat, 0) - 1; i >= 0; i--)
          ro[i] = *(ro_loc[i] = &XVECEXP (pat, 0, i));
      break;

    case 365:  /* prefetch_32 */
    case 364:  /* prefetch_64 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 2));
      break;

    case 363:  /* *return_sf */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 360:  /* *return_di */
    case 357:  /* *return_df_no_fpu */
    case 356:  /* *return_sf_no_fpu */
    case 355:  /* *return_si */
    case 354:  /* *return_hi */
    case 353:  /* *return_qi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 352:  /* ffssi2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 351:  /* flushdi */
    case 350:  /* flush */
    case 348:  /* goto_handler_and_restore */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      break;

    case 346:  /* *branch_sp64 */
    case 345:  /* *branch_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 343:  /* update_return */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 1));
      break;

    case 366:  /* trap */
    case 349:  /* do_builtin_setjmp_setup */
    case 347:  /* flush_register_windows */
    case 344:  /* nop */
    case 342:  /* blockage */
      break;

    case 333:  /* *call_symbolic_untyped_struct_value_sp32 */
    case 332:  /* *call_address_untyped_struct_value_sp32 */
    case 331:  /* *call_symbolic_struct_value_sp32 */
    case 330:  /* *call_address_struct_value_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (pat, 0, 1));
      break;

    case 339:  /* *sibcall_symbolic_sp64 */
    case 338:  /* *sibcall_symbolic_sp32 */
    case 329:  /* *call_symbolic_sp64 */
    case 328:  /* *call_address_sp64 */
    case 327:  /* *call_symbolic_sp32 */
    case 326:  /* *call_address_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 325:  /* *tablejump_sp64 */
    case 324:  /* *tablejump_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 322:  /* *sparc.md:7915 */
    case 321:  /* *sparc.md:7897 */
    case 315:  /* *lshrsi3_extend */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 320:  /* *sparc.md:7878 */
    case 319:  /* *sparc.md:7859 */
    case 311:  /* *ashrsi3_extend2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 273:  /* *cmp_ccx_set64 */
    case 272:  /* *cmp_cc_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 257:  /* *cmp_ccx_arith_op_not_set */
    case 256:  /* *cmp_cc_arith_op_not_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 255:  /* *cmp_ccx_arith_op_not */
    case 254:  /* *cmp_cc_arith_op_not */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 253:  /* *cmp_ccx_xor_not_set */
    case 252:  /* *cmp_cc_xor_not_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 251:  /* *cmp_ccx_xor_not */
    case 250:  /* *cmp_cc_xor_not */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 249:  /* *cmp_ccx_arith_op_set */
    case 248:  /* *cmp_cc_arith_op_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 247:  /* *cmp_ccx_arith_op */
    case 246:  /* *cmp_cc_arith_op */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 226:  /* *umacdi */
    case 225:  /* *smacdi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 224:  /* *smacsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 219:  /* *cmp_sdiv_cc_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 318:  /* lshrdi3_v8plus */
    case 313:  /* ashrdi3_v8plus */
    case 306:  /* ashldi3_v8plus */
    case 217:  /* divsi3_sp64 */
    case 216:  /* divsi3_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 215:  /* const_umulsi3_highpart */
    case 205:  /* const_smulsi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 214:  /* *umulsi3_highpart_sp32 */
    case 204:  /* *smulsi3_highpart_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      break;

    case 213:  /* const_umulsi3_highpart_v8plus */
    case 203:  /* const_smulsi3_highpart_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 212:  /* umulsi3_highpart_v8plus */
    case 202:  /* *sparc.md:5996 */
    case 201:  /* smulsi3_highpart_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 316:  /* *lshrsi3_extend2 */
    case 238:  /* *or_not_si */
    case 237:  /* *or_not_di_sp64 */
    case 236:  /* *or_not_di_sp32 */
    case 232:  /* *and_not_si */
    case 231:  /* *and_not_di_sp64 */
    case 230:  /* *and_not_di_sp32 */
    case 210:  /* const_umulsidi3_sp64 */
    case 209:  /* const_umulsidi3_sp32 */
    case 200:  /* const_mulsidi3_sp64 */
    case 199:  /* const_mulsidi3_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 284:  /* *multf3_extend */
    case 283:  /* *muldf3_extend */
    case 208:  /* *umulsidi3_sp64 */
    case 207:  /* *umulsidi3_sp32 */
    case 198:  /* *mulsidi3_sp64 */
    case 197:  /* *mulsidi3_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 211:  /* const_umulsidi3_v8plus */
    case 196:  /* const_mulsidi3_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 206:  /* umulsidi3_v8plus */
    case 195:  /* mulsidi3_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 193:  /* muldi3_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 184:  /* *sparc.md:5660 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      break;

    case 223:  /* *cmp_udiv_cc_set */
    case 194:  /* *cmp_mul_set */
    case 190:  /* *cmp_minus_ccx_set */
    case 189:  /* cmp_minus_cc_set */
    case 182:  /* *cmp_ccx_plus_set */
    case 181:  /* *cmp_cc_plus_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 188:  /* *cmp_minus_ccx */
    case 187:  /* *cmp_minus_cc */
    case 180:  /* *cmp_ccx_plus */
    case 179:  /* *cmp_cc_plus */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 175:  /* *subx_extend */
    case 174:  /* *subx_extend_sp64 */
    case 172:  /* *addx_extend_sp64 */
    case 171:  /* *addx_extend_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 362:  /* *return_losum_di */
    case 361:  /* *return_adddi */
    case 359:  /* *return_losum_si */
    case 358:  /* *return_addsi */
    case 183:  /* *subdi3_sp32 */
    case 169:  /* adddi3_insn_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 150:  /* *cmp_zero_extract_sp64 */
    case 149:  /* *cmp_zero_extract */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 138:  /* *cmp_zero_extendqidi2_andcc_set */
    case 134:  /* *cmp_zero_extendqisi2_andcc_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 308:  /* *cmp_cc_set_ashift_1 */
    case 271:  /* *cmp_ccx_set_not */
    case 270:  /* *cmp_cc_set_not */
    case 264:  /* *cmp_ccx_set_neg */
    case 263:  /* *cmp_cc_set_neg */
    case 142:  /* *cmp_diqi_trunc_set */
    case 140:  /* *cmp_siqi_trunc_set */
    case 137:  /* *cmp_zero_extendqidi2_set */
    case 133:  /* *cmp_zero_extendqisi2_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 323:  /* jump */
    case 136:  /* *cmp_zero_qi_sp64 */
    case 132:  /* *cmp_zero_qi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 307:  /* *cmp_cc_ashift_1 */
    case 269:  /* *cmp_ccx_not */
    case 268:  /* *cmp_cc_not */
    case 262:  /* *cmp_ccx_neg */
    case 261:  /* *cmp_cc_neg */
    case 141:  /* *cmp_diqi_trunc */
    case 139:  /* *cmp_siqi_trunc */
    case 135:  /* *cmp_zero_extendqidi2 */
    case 131:  /* *cmp_zero_extendqisi2 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 123:  /* *movtf_cc_reg_sp64 */
    case 122:  /* *movtf_cc_reg_hq_sp64 */
    case 121:  /* movdf_cc_reg_sp64 */
    case 120:  /* *movsf_cc_reg_sp64 */
    case 119:  /* *movdi_cc_reg_sp64_trunc */
    case 118:  /* *movdi_cc_reg_sp64 */
    case 117:  /* *movsi_cc_reg_sp64 */
    case 116:  /* *movhi_cc_reg_sp64 */
    case 115:  /* *movqi_cc_reg_sp64 */
    case 114:  /* *movtf_cc_sp64 */
    case 113:  /* *movtf_cc_hq_sp64 */
    case 112:  /* movdf_cc_sp64 */
    case 111:  /* *movsf_cc_sp64 */
    case 110:  /* *movdi_cc_sp64_trunc */
    case 109:  /* *movdi_cc_sp64 */
    case 108:  /* *movsi_cc_sp64 */
    case 107:  /* *movhi_cc_sp64 */
    case 106:  /* *movqi_cc_sp64 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 80:  /* embmedany_brsum */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 65:  /* *movdi_lo_sum_pic_label_ref */
    case 57:  /* *movsi_lo_sum_pic_label_ref */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 1));
      break;

    case 64:  /* *movdi_high_pic_label_ref */
    case 56:  /* *movsi_high_pic_label_ref */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 1));
      break;

    case 82:  /* embmedany_texthi */
    case 81:  /* embmedany_textuhi */
    case 78:  /* embmedany_sethi */
    case 75:  /* setlm */
    case 74:  /* sethh */
    case 71:  /* seth44 */
    case 67:  /* movdi_high_pic */
    case 55:  /* movsi_high_pic */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0));
      break;

    case 83:  /* embmedany_textulo */
    case 76:  /* sethm */
    case 72:  /* setm44 */
    case 66:  /* movdi_lo_sum_pic */
    case 54:  /* movsi_lo_sum_pic */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      break;

    case 368:  /* *sparc.md:9135 */
    case 367:  /* *sparc.md:9128 */
    case 105:  /* *movtf_no_e_insn_sp64 */
    case 104:  /* *movtf_insn_vis_sp64 */
    case 103:  /* *movtf_insn_sp64 */
    case 102:  /* *movtf_insn_hq_vis_sp64 */
    case 101:  /* *movtf_insn_hq_sp64 */
    case 100:  /* *movtf_no_e_insn_sp32 */
    case 99:  /* *movtf_insn_vis_sp32 */
    case 98:  /* *movtf_insn_sp32 */
    case 97:  /* *movdf_no_e_insn_sp64 */
    case 96:  /* *movdf_insn_sp64_vis */
    case 95:  /* *movdf_insn_sp64_novis */
    case 94:  /* *movdf_insn_v9only_vis */
    case 93:  /* *movdf_insn_v9only_novis */
    case 92:  /* *movdf_no_e_insn_v9_sp32 */
    case 91:  /* *movdf_no_e_insn_sp32 */
    case 90:  /* *movdf_insn_sp32 */
    case 87:  /* *movsf_no_f_insn */
    case 86:  /* *movsf_insn_vis */
    case 85:  /* *movsf_insn_novis */
    case 63:  /* *movdi_insn_sp64_vis */
    case 62:  /* *movdi_insn_sp64_novis */
    case 61:  /* *movdi_const64_special */
    case 60:  /* *movdi_sp64_dbl */
    case 59:  /* *movdi_insn_sp32 */
    case 58:  /* *movdi_insn_sp32_v9 */
    case 51:  /* *movsi_insn */
    case 50:  /* *movsi_const64_special */
    case 48:  /* *movhi_insn */
    case 47:  /* *movhi_const64_special */
    case 46:  /* *movqi_insn */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 45:  /* get_pc */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      break;

    case 44:  /* *inverted_int_branch_sp64 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 43:  /* *normal_int_branch_sp64 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 42:  /* *inverted_fpe_branch */
    case 40:  /* *inverted_fp_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 41:  /* *normal_fpe_branch */
    case 39:  /* *normal_fp_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 38:  /* *inverted_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 37:  /* *normal_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 34:  /* *x_minus_sltu_plus_y */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 310:  /* *ashrsi3_extend */
    case 245:  /* *xor_not_si */
    case 244:  /* *xor_not_di_sp64 */
    case 243:  /* *xor_not_di_sp32 */
    case 173:  /* subx */
    case 170:  /* addx */
    case 33:  /* *x_minus_y_minus_sltu */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 31:  /* *sltu_plus_x_plus_y */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 27:  /* *neg_sltu_plus_x */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 35:  /* *sgeu_plus_x */
    case 30:  /* *sltu_plus_x */
    case 26:  /* *neg_sltu_minus_x */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 29:  /* *neg_sgeu_insn */
    case 28:  /* *sgeu_insn */
    case 25:  /* *neg_sltu_insn */
    case 24:  /* *sltu_insn */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 23:  /* *x_minus_i_eq_0 */
    case 21:  /* *x_minus_i_ne_0 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      break;

    case 341:  /* *sibcall_value_symbolic_sp64 */
    case 340:  /* *sibcall_value_symbolic_sp32 */
    case 337:  /* *call_value_symbolic_sp64 */
    case 336:  /* *call_value_address_sp64 */
    case 335:  /* *call_value_symbolic_sp32 */
    case 334:  /* *call_value_address_sp32 */
    case 176:  /* *sparc.md:5464 */
    case 22:  /* *x_plus_i_eq_0 */
    case 20:  /* *x_plus_i_ne_0 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 167:  /* fix_truncdfdi2 */
    case 166:  /* fix_truncsfdi2 */
    case 164:  /* fix_truncdfsi2 */
    case 163:  /* fix_truncsfsi2 */
    case 18:  /* *neg_seqdi_zero */
    case 12:  /* *neg_snedi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 304:  /* *ashldi3_const1 */
    case 303:  /* *ashlsi3_const1 */
    case 301:  /* sqrtsf2 */
    case 300:  /* sqrtdf2 */
    case 299:  /* *sqrttf2_hq */
    case 298:  /* abssf2 */
    case 297:  /* *absdf2_v9 */
    case 296:  /* *absdf2_notv9 */
    case 295:  /* *abstf2_v9 */
    case 294:  /* *abstf2_hq_v9 */
    case 293:  /* *abstf2_notv9 */
    case 292:  /* negsf2 */
    case 291:  /* *negdf2_v9 */
    case 290:  /* *negdf2_notv9 */
    case 289:  /* *negtf2_v9 */
    case 288:  /* *negtf2_notv9 */
    case 267:  /* one_cmplsi2 */
    case 266:  /* *one_cmpldi2_sp64 */
    case 265:  /* *one_cmpldi2_sp32 */
    case 260:  /* negsi2 */
    case 259:  /* *negdi2_sp64 */
    case 168:  /* *fix_trunctfdi2_hq */
    case 165:  /* *fix_trunctfsi2_hq */
    case 162:  /* *floatditf2_hq */
    case 161:  /* floatdidf2 */
    case 160:  /* floatdisf2 */
    case 159:  /* *floatsitf2_hq */
    case 158:  /* floatsidf2 */
    case 157:  /* floatsisf2 */
    case 156:  /* *trunctfdf2_hq */
    case 155:  /* *trunctfsf2_hq */
    case 154:  /* truncdfsf2 */
    case 153:  /* *extenddftf2_hq */
    case 152:  /* *extendsftf2_hq */
    case 151:  /* extendsfdf2 */
    case 148:  /* *sign_extendsidi2_insn */
    case 147:  /* *sign_extendhidi2_insn */
    case 146:  /* *sign_extendqidi2_insn */
    case 145:  /* *sign_extendqisi2_insn */
    case 144:  /* *sign_extendqihi2_insn */
    case 143:  /* *sign_extendhisi2_insn */
    case 130:  /* *zero_extendsidi2_insn_sp32 */
    case 129:  /* *zero_extendsidi2_insn_sp64 */
    case 128:  /* *zero_extendhidi2_insn */
    case 127:  /* *zero_extendqidi2_insn */
    case 126:  /* *zero_extendqisi2_insn */
    case 125:  /* *zero_extendqihi2_insn */
    case 124:  /* *zero_extendhisi2_insn */
    case 89:  /* *movsf_high */
    case 69:  /* *sethi_di_medlow */
    case 68:  /* *sethi_di_medlow_embmedany_pic */
    case 53:  /* *movsi_high */
    case 36:  /* *x_minus_sgeu */
    case 32:  /* *x_minus_sltu */
    case 19:  /* *seqdi_zero_trunc */
    case 17:  /* *seqdi_zero */
    case 13:  /* *snedi_zero_trunc */
    case 11:  /* *snedi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 15:  /* *neg_seqsi_zero */
    case 9:  /* *neg_snesi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      break;

    case 258:  /* *negdi2_sp32 */
    case 16:  /* *seqsi_zero_extend */
    case 14:  /* *seqsi_zero */
    case 10:  /* *snesi_zero_extend */
    case 8:  /* *snesi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      break;

    case 317:  /* *sparc.md:7833 */
    case 314:  /* lshrsi3 */
    case 312:  /* *sparc.md:7736 */
    case 309:  /* ashrsi3 */
    case 305:  /* *ashldi3_sp64 */
    case 302:  /* ashlsi3 */
    case 287:  /* divsf3 */
    case 286:  /* divdf3 */
    case 285:  /* *divtf3_hq */
    case 282:  /* mulsf3 */
    case 281:  /* muldf3 */
    case 280:  /* *multf3_hq */
    case 279:  /* subsf3 */
    case 278:  /* subdf3 */
    case 277:  /* *subtf3_hq */
    case 276:  /* addsf3 */
    case 275:  /* adddf3 */
    case 274:  /* *addtf3_hq */
    case 242:  /* xorsi3 */
    case 241:  /* *xordi3_sp64_dbl */
    case 240:  /* *xordi3_sp64 */
    case 239:  /* *xordi3_sp32 */
    case 235:  /* iorsi3 */
    case 234:  /* *iordi3_sp64 */
    case 233:  /* *iordi3_sp32 */
    case 229:  /* andsi3 */
    case 228:  /* *anddi3_sp64 */
    case 227:  /* *anddi3_sp32 */
    case 222:  /* udivdi3 */
    case 221:  /* udivsi3_sp64 */
    case 220:  /* udivsi3_sp32 */
    case 218:  /* divdi3 */
    case 192:  /* *muldi3_sp64 */
    case 191:  /* mulsi3 */
    case 186:  /* *subsi3 */
    case 185:  /* *subdi3_sp64 */
    case 178:  /* *addsi3 */
    case 177:  /* *adddi3_sp64 */
    case 88:  /* *movsf_lo_sum */
    case 84:  /* embmedany_textlo */
    case 79:  /* embmedany_losum */
    case 77:  /* setlo */
    case 73:  /* setl44 */
    case 70:  /* *losum_di_medlow */
    case 52:  /* *movsi_lo_sum */
    case 49:  /* *movhi_lo_sum */
    case 7:  /* *cmptf_fp */
    case 6:  /* *cmpdf_fp */
    case 5:  /* *cmpsf_fp */
    case 4:  /* *cmptf_fpe */
    case 3:  /* *cmpdf_fpe */
    case 2:  /* *cmpsf_fpe */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 1:  /* *cmpdi_sp64 */
    case 0:  /* *cmpsi_insn */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    default:
      abort ();
    }
}
